
//SAMPLE: this file subclasses a CListCtrl window and
// forces it to scroll to the left edge of each column 

// SnapList.cpp : implementation file
//

#include "stdafx.h"
#include "scrl.h"
#include "SnapList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSnapList

CSnapList::CSnapList()
{
}

CSnapList::~CSnapList()
{
}


BEGIN_MESSAGE_MAP(CSnapList, CListCtrl)
	//{{AFX_MSG_MAP(CSnapList)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSnapList message handlers

//SAMPLE
// this function handles the scrolling behaviour.
void CSnapList::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	if (nSBCode != SB_ENDSCROLL)
	{
		// get the header control, and count of columns
		CHeaderCtrl* pHeader = (CHeaderCtrl*) GetDlgItem(0);
		ASSERT(pHeader != NULL);
		int nCols = pHeader->GetItemCount();

		// measure the current status of the scrollbar
		SCROLLINFO infoBefore, infoAfter;
		int nTotal = 0;
		GetScrollInfo(SB_HORZ, &infoBefore);

		// perform the default scrolling
		CListCtrl::OnHScroll(nSBCode, nPos, pScrollBar);

		// measure the resulting status of the scrollbar
		GetScrollInfo(SB_HORZ, &infoAfter);

		// based on what scrolling was done, snap the position
		// didn't move
		if (infoAfter.nPos == infoBefore.nPos)
			return;

		// went right
		if (infoAfter.nPos > infoBefore.nPos)
		{
			// try to find the nearest column, rounding up
			int nIndex;
			for (nIndex = 0; nIndex < nCols; nIndex++)
			{
				HD_ITEM item;
				item.mask =  HDI_WIDTH;
				pHeader->GetItem(nIndex, &item);
				nTotal += item.cxy;
				if (nTotal > infoAfter.nPos)
					break;
			}

			CSize sz(nTotal - infoAfter.nPos, 0);
			Scroll(sz);
			return;
		}
		else // went left
		{
			// try to find the nearest column, rounding down
			int nIndex;
			for (nIndex = 0; nIndex < nCols; nIndex++)
			{
				HD_ITEM item;
				item.mask =  HDI_WIDTH;
				pHeader->GetItem(nIndex, &item);
				nTotal += item.cxy;
				if (infoAfter.nPos < nTotal)
				{
					nTotal -= item.cxy;
					break;
				}
			}

		}

		// force scroll to newly computed spot
		CSize sz(nTotal - infoAfter.nPos, 0);
		Scroll(sz);
		return;
	}
	else
		CListCtrl::OnHScroll(nSBCode, nPos, pScrollBar);
}
